config/routes.rb
Rails.application.routes.draw do
  root 'welcome#index'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  resources :subjects
  resources :categories
  resources :welcome
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/category.rb
class Category < ApplicationRecord
  belongs_to :subject
end

app/models/question.rb
class Question < ApplicationRecord
  belongs_to :subject
end

app/models/subject.rb
class Subject < ApplicationRecord
  has_many :categories
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :set_category, only: [:show, :edit, :update, :destroy]
  def index
    @categories = Category.all
  end

  def show
  end

  def new
    @category = Category.new
  end

  def create
    @category = Category.new(category_params)
    if @category.save
      redirect_to @category
    else
      render :new
    end
  end

  def edit
  end

  def update
    if @category.update_attributes(category_params)
      redirect_to @category
    else
      render :edit
    end
  end

  def destroy
    @category.destroy
    redirect_to categories_path
  end

  private

  def set_category
    @category = Category.find(params[:id])
  end

  def category_params
    params.require(:category).permit(:name, :subject_id)
  end
end

app/controllers/subjects_controller.rb
class SubjectsController < ApplicationController
  before_action :set_subject, only: [:show, :edit, :update, :destroy]
  def index
    @subjects = Subject.all
  end

  def show
    @categories = @subject.categories
  end

  def new
    @subject = Subject.new
  end

  def create
    @subject = Subject.new(subject_params)
    if @subject.save
      redirect_to @subject
    else
      render :new
    end
  end

  def edit
  end

  def update
    if @subject.update_attributes(subject_params)
      redirect_to @subject
    else
      render :edit
    end
  end

  def destroy
    @subject.destroy
    redirect_to subjects_path
  end

  private

  def set_subject
    @subject = Subject.find(params[:id])
  end

  def subject_params
    params.require(:subject).permit(:name)
  end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/categories/_category.html.erb
<tr>
  <th scope="row"><%= category.id %></th>
  <td><%= category.name%></td>
  <td><%= category.subject.name%></td>
  <td>
    <%= link_to 'Details', category_path(category), class: 'btn btn-outline-success'%>
    <%= link_to 'Edit', edit_category_path(category), class: 'btn btn-outline-primary'%>
    <%= link_to 'Delete', category_path(category), method: :delete, data:{confirm: 'Are you sure?'}, class: 'btn btn-outline-danger'%>
  </td>

</tr>

app/views/categories/_form.html.erb
<%= form_for @category do |f|%>
  <div class="form-group">
    <%= f.label :name %>
    <%= f.text_field :name, class: 'form-control'%>
  </div>
  <div class="form-group ">
    <%= f.label :subject_id %>
    <%= f.collection_select :subject_id, Subject.order(:name),:id, :name,{include_blank: true},{:class => 'custom-select'}%>
  </div>
  <div class="form-group">
    <%= f.submit 'Сохранить', class: 'btn btn-primary' %>
  </div>
<% end %>

app/views/categories/edit.html.erb
<h2>Редактирование категории</h2>

<%= render 'form' %>

app/views/categories/index.html.erb
<%= link_to 'Новая категория', new_category_path, class: 'btn btn-success primary'%>

<table class="table">
  <thead>
  <tr>
    <th scope="col">#</th>
    <th scope="col">Category</th>
    <th scope="col">Subject</th>
    <th scope="col">Options</th>
  </tr>
  </thead>
  <tbody>
  <%= render @categories %>
  </tbody>
</table>

app/views/categories/new.html.erb
<h2>Новая категория</h2>

<%= render 'form'%>

app/views/categories/show.html.erb
<h3><%= @category.name %></h3>
<%# if @category. %>
<!--  <ul>-->
    <%# @categories.each do |category| %>
<!--      <li><%#= link_to category.name, category_path(category) %></li>-->
    <%# end %>
<!--  </ul>-->
<%# else %>
<!--  Категории в разработке-->
<%# end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>CourseProjectRis</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
  <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
    <%= link_to 'Navbar', root_path, class: 'navbar-brand' %>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item">
          <%= link_to 'Subject', subjects_path, class: 'nav-link' %>
        </li>
        <li class="nav-item">
          <%= link_to 'Category', categories_path, class: 'nav-link' %>
        </li>
<!--        <li class="nav-item">-->
          <%#= link_to 'Question', questions_path, class: 'nav-link' %>
<!--        </li>-->
      </ul>


    </div>
  </nav>
  <div class="container">
    <%= yield %>
  </div>

  </body>
</html>

app/views/subjects/_form.html.erb
<%= form_for @subject do |f|%>
  <div class="form-group">
    <%= f.label :name %>
    <%= f.text_field :name, class: 'form-control'%>
  </div>

  <div class="form-group">
    <%= f.submit 'Сохранить', class: 'btn btn-primary' %>
  </div>
<% end %>

app/views/subjects/_subject.html.erb
<tr>
  <th scope="row"><%= subject.id %></th>
  <td><%= subject.name%></td>
  <td>
    <%= link_to 'Details', subject_path(subject), class: 'btn btn-outline-success'%>
    <%= link_to 'Edit', edit_subject_path(subject), class: 'btn btn-outline-primary'%>
    <%= link_to 'Delete', subject_path(subject), method: :delete, data:{confirm: 'Are you sure?'}, class: 'btn btn-outline-danger'%>
  </td>

</tr>

app/views/subjects/edit.html.erb
<h2>Редактирование предмета</h2>

<%= render 'form'%>

app/views/subjects/index.html.erb
<%= link_to 'Новый предмет', new_subject_path, class: 'btn btn-success primary'%>

<table class="table">
  <thead>
  <tr>
    <th scope="col">#</th>
    <th scope="col">Subject</th>
    <th scope="col">Options</th>
  </tr>
  </thead>
  <tbody>
  <%= render @subjects %>
  </tbody>
</table>

app/views/subjects/new.html.erb
<h2>Новый предмет</h2>

<%= render 'form'%>

app/views/subjects/show.html.erb
<h3><%= @subject.name %></h3>
<% if @subject.categories.present? %>
<ul>
  <% @categories.each do |category| %>
    <li><%= link_to category.name, category_path(category) %></li>
  <% end %>
</ul>
<% else %>
  Категории в разработке
<% end %>

app/views/welcome/index.html.erb
<p>
  Добро пожаловать на сайт
</p>